<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;

class AssetPublish extends Command
{
    protected $signature = 'cms:asset-publish';
    protected $description = 'Publish admin assets';

    public function handle()
    {
        // TODO: relative path for linux
        $src = realpath(base_path('vendor/altsolution/cms-core/assets'));
        $dstDir = public_path('vendor');
        $dstFile = 'admin';
        $dstPath = $dstDir . DIRECTORY_SEPARATOR . $dstFile;

        if (!is_dir($src)) {
            $this->error('Assets not found. Run composer install first');
            return;
        }

        if (is_file($dstPath)) {
            $this->error('File already exists: ' . $dstPath);
            return;
        }

        app('files')->link($src, $dstPath);
        //app('files')->relativeLink($src, $dstPath);

        $this->line('Symlink created: ' . $src . ' <=> ' . $dstPath);
    }
}
