<?php

namespace AltSolution\Admin\Cron;

use AltSolution\Admin\Models\Cron;
use Carbon\Carbon;
use Illuminate\Database\Eloquent\Collection;

interface RepositoryInterface
{
    /**
     * @return Cron[]|Collection
     */
    public function getAll();

    /**
     * @return void
     */
    public function cleanCache();

    /**
     * @param Cron $cron
     * @param Carbon $start
     * @param Carbon $end
     * @param string $output
     * @return void
     */
    public function addLog(Cron $cron, Carbon $start, Carbon $end, $output);

    /**
     * @return void
     */
    public function truncLog(Cron $cron);

    /**
     * @return void
     */
    public function flushLog();
}