<?php

namespace AltSolution\Admin\Form\Field;

use AltSolution\Admin\Form\AbstractField;
use Illuminate\Database\Eloquent\Collection;

class Choice extends AbstractField
{
    use ChoicesTrait;

    protected $view = 'choice';

    protected function customViewData()
    {
        $choices = $this->getChoices();
        $multiple = $this->getOption('multiple', false);
        $inline = $this->getOption('inline', false);

        return compact('choices', 'multiple', 'inline');
    }

    public function normalizeValue($value)
    {
        // for eloquent relations
        if ($this->getOption('multiple')) {
            if ($value instanceof Collection) {
                return $value->modelKeys();
            }
        }
        return $value;
    }

    public function getValidationName()
    {
        $name = $this->getName();
        // array validation
        if ($this->getOption('multiple')) {
            $name .= '.*';
        }

        return $name;
    }
}
