<?php

namespace AltSolution\Admin\Form\Field;

use Exception;
use Traversable;

trait ChoicesTrait
{
    protected function getChoices()
    {
        // TODO: weak check for 'ajax'
        if (!isset($this->options['choices']) && !isset($this->options['ajax'])) {
            $baseClassName = substr(strrchr(get_class($this), '\\'), 1);
            throw new Exception($baseClassName . ' field must have choices');
        }

        $choicesRaw = $this->getOption('choices', []);

        // handle generators first
        if (is_callable($choicesRaw)) {
            $choicesRaw = call_user_func($choicesRaw);
        } 
        
        if (is_array($choicesRaw)) {
            return $choicesRaw;
        } elseif ($choicesRaw instanceof Traversable) {
            return iterator_to_array($choicesRaw);
        } else {
            throw new Exception('Select field must have valid choices');
        }
    }
}
