<?php

namespace AltSolution\Admin\Form\Field;

use AltSolution\Admin\Form\AbstractField;
use AltSolution\Admin\Upload\UploadsInterface;
use AltSolution\Admin\Rules\ValidSvg;
use Illuminate\Support\Arr;

class Svg extends AbstractField
{
    protected $view = 'svg';

    protected function getRules()
    {
        return [
            'file',
            new ValidSvg(),
        ];
    }

    protected function customViewData()
    {
        $empty = $this->normalizeBoolean($this->getOption('empty', true));

        $image = null;
        $name_delete = null;
        if ($this->getValue()) {
            $dataSource = $this->getForm()->getData();
            if (strpos($this->name, '.') === false) {
                if (!$dataSource instanceof UploadsInterface) {
                    throw new \Exception('Data source not implements UploadsInterface');
                }
                $image = $dataSource->uploadUrl($this->name);
            } else {
                $pos = strrpos($this->name, '.');
                $ns = substr($this->name, 0, $pos);
                $name = substr($this->name, $pos + 1);

                $ds = Arr::get($dataSource, $ns);
                if (!$ds instanceof UploadsInterface) {
                    throw new \Exception('Data source not implements UploadsInterface');
                }
                $image = $ds->uploadUrl($name);
            }

            $name_delete = $this->transformName($this->name . '_delete');
        }

        return compact('empty', 'image', 'name_delete');
    }
}