<?php

namespace AltSolution\Admin\Forms;

use AltSolution\Admin\Form;
use AltSolution\Admin\Modules\Content\ContentFormInterface;

class ContentForm extends Form\AbstractFactory implements ContentFormInterface
{
    public function buildForm(Form\BuilderInterface $builder)
    {
        $itemId = $builder->getData('id');

        $builder->form([
            'method' => 'post',
            'enctype' => 'multipart/form-data',
            'action' => route('admin::content_save'),
        ]);

        $builder->hidden('id');
        $builder->checkbox('is_published', [
            'label' => trans('admin::content.settings'),
            'placeholder' => trans('admin::content.publish'),
        ]);
        $currentLocale = cms_default_locale();
        $builder->slug('slug', [
            'source' => 'title_' . $currentLocale,
            'enable' => 'unless:id',
            'label' => trans('admin::common.f_slug'),
            'required' => true,
            'rules' => 'unique:contents,slug,' . $itemId,
        ]);
        foreach (cms_locales() as $locale) {
            $builder->text('title_' . $locale, [
                'label' => trans('admin::content.name'),
                'required' => $locale == $currentLocale,
            ]);
            $builder->wysiwyg('content_' . $locale, [
                'label' => trans('admin::content.content'),
            ]);
        }
    }
}