<?php

namespace AltSolution\Admin\Models;

use AltSolution\Admin\Seo\SeoInterface;
use AltSolution\Admin\Seo\SeoTrait;
use AltSolution\Admin\Locale\TranslateInterface;
use AltSolution\Admin\Locale\TranslateTrait;
use AltSolution\Admin\Modules\Content\ContentModelInterface;
use Illuminate\Database\Eloquent\Model;

class Content extends Model implements TranslateInterface, SeoInterface, ContentModelInterface
{
    use TranslateTrait;
    use SeoTrait;

    protected $table = 'contents';
    protected $fillable = [
        'title_*',
        'content_*',
        'slug',
        'is_published',
    ];

    public function user()
    {
        return $this->belongsTo(User::class);
    }
}
