<?php

namespace AltSolution\Admin\Models;

use Illuminate\Database\Eloquent\Model;

class CronLog extends Model
{
    protected $table = 'cron_log';
    protected $fillable = [
        'cron_id',
        'start_at',
        'end_at',
        'exit_code',
        'output',
    ];
    public $timestamps = false;
    protected $dates = [
        'start_at',
        'end_at',
    ];

    public function getDurationAttribute()
    {
        $diff = $this->start_at->diff($this->end_at);
        return $diff->format('%H:%I:%S');
    }

    public function cron()
    {
        return $this->belongsTo(Cron::class);
    }
}
